Index: sasmodels/models/fractal_core_shell.py
===================================================================
--- sasmodels/models/fractal_core_shell.py	(revision 217590bce5ffcf2c4de704a4770a9cab003dd287)
+++ sasmodels/models/fractal_core_shell.py	(revision 07300ea35d16b40f790fffc4ded20189ec5267a4)
@@ -1,42 +1,41 @@
 r"""
+Definition
+----------
 Calculates the scattering from a fractal structure with a primary building
 block of core-shell spheres, as opposed to just homogeneous spheres in
-the fractal model.
-This model could find use for aggregates of coated particles, or aggregates
-of vesicles.
-
-Definition
-----------
+the fractal model. It is an extension of the well known Teixeira\ [#teixeira]_
+fractal model replacing the $P(q)$ of a solid sphere with that of a core-shell
+sphere. This model could find use for aggregates of coated particles, or
+aggregates of vesicles for example.
 
 .. math::
 
-    I(q) = \text{background} + P(q)S(q)
+    I(q) = P(q)S(q) + \text{background}
 
-The form factor $P(q)$ is that from core_shell model with $bkg$ = 0
-
+Where $P(q)$ is the core-shell form factor and $S(q)$ is the
+Teixeira\ [#teixeira]_ fractal structure factor both of which are given again
+below:
 
 .. math::
 
-    P(q)=\frac{scale}{V_s}\left[3V_c(\rho_c-\rho_s)
+    P(q) &= \frac{\phi}{V_s}\left[3V_c(\rho_c-\rho_s)
     \frac{\sin(qr_c)-qr_c\cos(qr_c)}{(qr_c)^3}+
     3V_s(\rho_s-\rho_{solv})
     \frac{\sin(qr_s)-qr_s\cos(qr_s)}{(qr_s)^3}\right]^2
 
+    S(q) &= 1 + \frac{D_f\ \Gamma\!(D_f-1)}{[1+1/(q\xi)^2]^{(D_f-1)/2}} 
+    \frac{\sin[(D_f-1)\tan^{-1}(q\xi)]}{(qr_s)^{D_f}}
 
-while the fractal structure factor $S(q)$ is
+where $\phi$ is the volume fraction of particles, $V_s$ is the volume of the
+whole particle, $V_c$ is the volume of the core, $\rho_c$, $\rho_s$, and
+$\rho_{solv}$ are the scattering length densities of the core, shell, and
+solvent respectively, $r_c$ and $r_s$ are the radius of the core and the radius
+of the whole particle respectively, $D_f$ is the fractal dimension, and |xi| the
+correlation length.
+ 
+Polydispersity of radius and thickness are also provided for.
 
-.. math::
-
-    S(q) = \frac{D_f\Gamma(D_f-1)\sin((D_f-1)\tan^{-1}(q\xi))}
-    {(qr_c)^{D_f}\left(1+\frac{1}{q^2\xi ^2} \right)^{\frac{D_f-1}{2}}}
-
-where $D_f$ = fractal_dim, |xi| = cor_length, $r_c$ = (core) radius, and
-$scale$ = volume fraction.
-
-The fractal structure is as documented in the fractal model.
-Polydispersity of radius and thickness is provided for.
-
-For 2D data: The 2D scattering intensity is calculated in the same way as 1D,
-where the $q$ vector is defined as
+This model does not allow for anisotropy and thus the 2D scattering intensity
+is calculated in the same way as 1D, where the $q$ vector is defined as
 
 .. math::
@@ -44,8 +43,19 @@
     q = \sqrt{q_x^2 + q_y^2}
 
+Our model is derived from the form factor calculations implemented in IGOR
+macros by the NIST Center for Neutron Research\ [#Kline]_
+
 References
 ----------
 
-See the core_shell and fractal model descriptions
+.. [#teixeira] J Teixeira, *J. Appl. Cryst.*, 21 (1988) 781-785
+.. [#Kline]  S R Kline, *J Appl. Cryst.*, 39 (2006) 895
+
+Authorship and Verification
+----------------------------
+
+* **Author:** NIST IGOR/DANSE **Date:** pre 2010
+* **Last Modified by:** Paul Butler and Paul Kienzle **on:** November 27, 2016
+* **Last Reviewed by:** Paul Butler and Paul Kienzle **on:** November 27, 2016
 
 """
@@ -54,8 +64,19 @@
 
 name = "fractal_core_shell"
-title = ""
-description = """
+title = "Scattering from a fractal structure formed from core shell spheres"
+description = """\
+    Model for fractal aggregates of core-shell primary particles. It is based on
+    the Teixeira model for the S(q) of a fractal * P(q) for a core-shell sphere
 
-"""
+    radius =  the radius of the core
+    thickness = thickness of the shell
+    thick_layer = thickness of a layer
+    sld_core = the SLD of the core
+    sld_shell = the SLD of the shell
+    sld_solvent = the SLD of the solvent
+    volfraction = volume fraction of core-shell particles
+    fractal_dim = fractal dimension
+    cor_length = correlation length of the fractal like aggretates
+    """
 category = "shape-independent"
 
Index: sasmodels/models/stacked_disks.py
===================================================================
--- sasmodels/models/stacked_disks.py	(revision 98ce141a6e091b02f8139ab3b235c16dafbce663)
+++ sasmodels/models/stacked_disks.py	(revision 07300ea35d16b40f790fffc4ded20189ec5267a4)
@@ -83,6 +83,5 @@
 
 Our model is derived from the form factor calculations implemented in a
-c-library provided by the NIST Center for Neutron Research
-(Kline, 2006)\ [#CIT_Kline]_
+c-library provided by the NIST Center for Neutron Research\ [#CIT_Kline]_
 
 References