Index: sansmodels/src/sans/models/OnionModel.py
===================================================================
--- sansmodels/src/sans/models/OnionModel.py	(revision e096270047b0757e07e7187aa5de071c857a7e13)
+++ sansmodels/src/sans/models/OnionModel.py	(revision 7381f345e4f06f419f41279b0c7ddf73d3d8c755)
@@ -42,24 +42,24 @@
          sld_solv        = 6.4e-006 [1/A^(2)]
          background      = 0.0 [1/cm]
-         sld_out_shell1  = 2e-006 
-         sld_out_shell2  = 2.5e-006 
-         sld_out_shell3  = 3e-006 
-         sld_out_shell4  = 3.5e-006 
-         sld_out_shell5  = 4e-006 
-         sld_out_shell6  = 4.5e-006 
-         sld_out_shell7  = 5e-006 
-         sld_out_shell8  = 5.5e-006 
-         sld_out_shell9  = 6e-006 
-         sld_out_shell10 = 6.2e-006 
-         sld_in_shell1   = 1.7e-006 
-         sld_in_shell2   = 2.2e-006 
-         sld_in_shell3   = 2.7e-006 
-         sld_in_shell4   = 3.2e-006 
-         sld_in_shell5   = 3.7e-006 
-         sld_in_shell6   = 4.2e-006 
-         sld_in_shell7   = 4.7e-006 
-         sld_in_shell8   = 5.2e-006 
-         sld_in_shell9   = 5.7e-006 
-         sld_in_shell10  = 6e-006 
+         sld_out_shell1  = 2e-006 [1/A^(2)]
+         sld_out_shell2  = 2.5e-006 [1/A^(2)]
+         sld_out_shell3  = 3e-006 [1/A^(2)]
+         sld_out_shell4  = 3.5e-006 [1/A^(2)]
+         sld_out_shell5  = 4e-006 [1/A^(2)]
+         sld_out_shell6  = 4.5e-006 [1/A^(2)]
+         sld_out_shell7  = 5e-006 [1/A^(2)]
+         sld_out_shell8  = 5.5e-006 [1/A^(2)]
+         sld_out_shell9  = 6e-006 [1/A^(2)]
+         sld_out_shell10 = 6.2e-006 [1/A^(2)]
+         sld_in_shell1   = 1.7e-006 [1/A^(2)]
+         sld_in_shell2   = 2.2e-006 [1/A^(2)]
+         sld_in_shell3   = 2.7e-006 [1/A^(2)]
+         sld_in_shell4   = 3.2e-006 [1/A^(2)]
+         sld_in_shell5   = 3.7e-006 [1/A^(2)]
+         sld_in_shell6   = 4.2e-006 [1/A^(2)]
+         sld_in_shell7   = 4.7e-006 [1/A^(2)]
+         sld_in_shell8   = 5.2e-006 [1/A^(2)]
+         sld_in_shell9   = 5.7e-006 [1/A^(2)]
+         sld_in_shell10  = 6e-006 [1/A^(2)]
          A_shell1        = 1.0 
          A_shell2        = 1.0 
@@ -72,14 +72,14 @@
          A_shell9        = 1.0 
          A_shell10       = 1.0 
-         thick_shell1    = 50.0 
-         thick_shell2    = 50.0 
-         thick_shell3    = 50.0 
-         thick_shell4    = 50.0 
-         thick_shell5    = 50.0 
-         thick_shell6    = 50.0 
-         thick_shell7    = 50.0 
-         thick_shell8    = 50.0 
-         thick_shell9    = 50.0 
-         thick_shell10   = 50.0 
+         thick_shell1    = 50.0 [A]
+         thick_shell2    = 50.0 [A]
+         thick_shell3    = 50.0 [A]
+         thick_shell4    = 50.0 [A]
+         thick_shell5    = 50.0 [A]
+         thick_shell6    = 50.0 [A]
+         thick_shell7    = 50.0 [A]
+         thick_shell8    = 50.0 [A]
+         thick_shell9    = 50.0 [A]
+         thick_shell10   = 50.0 [A]
          func_shell1     = 2.0 
          func_shell2     = 2.0 
@@ -137,24 +137,24 @@
         self.details['sld_solv'] = ['[1/A^(2)]', None, None]
         self.details['background'] = ['[1/cm]', None, None]
-        self.details['sld_out_shell1'] = ['', None, None]
-        self.details['sld_out_shell2'] = ['', None, None]
-        self.details['sld_out_shell3'] = ['', None, None]
-        self.details['sld_out_shell4'] = ['', None, None]
-        self.details['sld_out_shell5'] = ['', None, None]
-        self.details['sld_out_shell6'] = ['', None, None]
-        self.details['sld_out_shell7'] = ['', None, None]
-        self.details['sld_out_shell8'] = ['', None, None]
-        self.details['sld_out_shell9'] = ['', None, None]
-        self.details['sld_out_shell10'] = ['', None, None]
-        self.details['sld_in_shell1'] = ['', None, None]
-        self.details['sld_in_shell2'] = ['', None, None]
-        self.details['sld_in_shell3'] = ['', None, None]
-        self.details['sld_in_shell4'] = ['', None, None]
-        self.details['sld_in_shell5'] = ['', None, None]
-        self.details['sld_in_shell6'] = ['', None, None]
-        self.details['sld_in_shell7'] = ['', None, None]
-        self.details['sld_in_shell8'] = ['', None, None]
-        self.details['sld_in_shell9'] = ['', None, None]
-        self.details['sld_in_shell10'] = ['', None, None]
+        self.details['sld_out_shell1'] = ['[1/A^(2)]', None, None]
+        self.details['sld_out_shell2'] = ['[1/A^(2)]', None, None]
+        self.details['sld_out_shell3'] = ['[1/A^(2)]', None, None]
+        self.details['sld_out_shell4'] = ['[1/A^(2)]', None, None]
+        self.details['sld_out_shell5'] = ['[1/A^(2)]', None, None]
+        self.details['sld_out_shell6'] = ['[1/A^(2)]', None, None]
+        self.details['sld_out_shell7'] = ['[1/A^(2)]', None, None]
+        self.details['sld_out_shell8'] = ['[1/A^(2)]', None, None]
+        self.details['sld_out_shell9'] = ['[1/A^(2)]', None, None]
+        self.details['sld_out_shell10'] = ['[1/A^(2)]', None, None]
+        self.details['sld_in_shell1'] = ['[1/A^(2)]', None, None]
+        self.details['sld_in_shell2'] = ['[1/A^(2)]', None, None]
+        self.details['sld_in_shell3'] = ['[1/A^(2)]', None, None]
+        self.details['sld_in_shell4'] = ['[1/A^(2)]', None, None]
+        self.details['sld_in_shell5'] = ['[1/A^(2)]', None, None]
+        self.details['sld_in_shell6'] = ['[1/A^(2)]', None, None]
+        self.details['sld_in_shell7'] = ['[1/A^(2)]', None, None]
+        self.details['sld_in_shell8'] = ['[1/A^(2)]', None, None]
+        self.details['sld_in_shell9'] = ['[1/A^(2)]', None, None]
+        self.details['sld_in_shell10'] = ['[1/A^(2)]', None, None]
         self.details['A_shell1'] = ['', None, None]
         self.details['A_shell2'] = ['', None, None]
@@ -167,14 +167,14 @@
         self.details['A_shell9'] = ['', None, None]
         self.details['A_shell10'] = ['', None, None]
-        self.details['thick_shell1'] = ['', None, None]
-        self.details['thick_shell2'] = ['', None, None]
-        self.details['thick_shell3'] = ['', None, None]
-        self.details['thick_shell4'] = ['', None, None]
-        self.details['thick_shell5'] = ['', None, None]
-        self.details['thick_shell6'] = ['', None, None]
-        self.details['thick_shell7'] = ['', None, None]
-        self.details['thick_shell8'] = ['', None, None]
-        self.details['thick_shell9'] = ['', None, None]
-        self.details['thick_shell10'] = ['', None, None]
+        self.details['thick_shell1'] = ['[A]', None, None]
+        self.details['thick_shell2'] = ['[A]', None, None]
+        self.details['thick_shell3'] = ['[A]', None, None]
+        self.details['thick_shell4'] = ['[A]', None, None]
+        self.details['thick_shell5'] = ['[A]', None, None]
+        self.details['thick_shell6'] = ['[A]', None, None]
+        self.details['thick_shell7'] = ['[A]', None, None]
+        self.details['thick_shell8'] = ['[A]', None, None]
+        self.details['thick_shell9'] = ['[A]', None, None]
+        self.details['thick_shell10'] = ['[A]', None, None]
         self.details['func_shell1'] = ['', None, None]
         self.details['func_shell2'] = ['', None, None]
Index: sansmodels/src/sans/models/c_extensions/onion.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/onion.h	(revision e096270047b0757e07e7187aa5de071c857a7e13)
+++ sansmodels/src/sans/models/c_extensions/onion.h	(revision 7381f345e4f06f419f41279b0c7ddf73d3d8c755)
@@ -54,44 +54,44 @@
 	double background;
 
-    //  [DEFAULT]=sld_out_shell1=2.0e-06
+    //  [DEFAULT]=sld_out_shell1=2.0e-06 [1/A^(2)]
     double sld_out_shell1;
-    //  [DEFAULT]=sld_out_shell2=2.5e-06
+    //  [DEFAULT]=sld_out_shell2=2.5e-06 [1/A^(2)]
     double sld_out_shell2;
-    //  [DEFAULT]=sld_out_shell3=3.0e-06
+    //  [DEFAULT]=sld_out_shell3=3.0e-06 [1/A^(2)]
     double sld_out_shell3;
-    //  [DEFAULT]=sld_out_shell4=3.5e-06
+    //  [DEFAULT]=sld_out_shell4=3.5e-06 [1/A^(2)]
     double sld_out_shell4;
-    //  [DEFAULT]=sld_out_shell5=4.0e-06
+    //  [DEFAULT]=sld_out_shell5=4.0e-06 [1/A^(2)]
     double sld_out_shell5;
-    //  [DEFAULT]=sld_out_shell6=4.5e-06
+    //  [DEFAULT]=sld_out_shell6=4.5e-06 [1/A^(2)]
     double sld_out_shell6;
-    //  [DEFAULT]=sld_out_shell7=5.0e-06
+    //  [DEFAULT]=sld_out_shell7=5.0e-06 [1/A^(2)]
     double sld_out_shell7;
-    //  [DEFAULT]=sld_out_shell8=5.5e-06
+    //  [DEFAULT]=sld_out_shell8=5.5e-06 [1/A^(2)]
     double sld_out_shell8;
-    //  [DEFAULT]=sld_out_shell9=6.0e-06
+    //  [DEFAULT]=sld_out_shell9=6.0e-06 [1/A^(2)]
     double sld_out_shell9;
-    //  [DEFAULT]=sld_out_shell10=6.2e-06
+    //  [DEFAULT]=sld_out_shell10=6.2e-06 [1/A^(2)]
     double sld_out_shell10;
 
-    //  [DEFAULT]=sld_in_shell1=1.7e-06
+    //  [DEFAULT]=sld_in_shell1=1.7e-06 [1/A^(2)]
     double sld_in_shell1;
-    //  [DEFAULT]=sld_in_shell2=2.2e-06
+    //  [DEFAULT]=sld_in_shell2=2.2e-06 [1/A^(2)]
     double sld_in_shell2;
-    //  [DEFAULT]=sld_in_shell3=2.7e-06
+    //  [DEFAULT]=sld_in_shell3=2.7e-06 [1/A^(2)]
     double sld_in_shell3;
-    //  [DEFAULT]=sld_in_shell4=3.2e-06
+    //  [DEFAULT]=sld_in_shell4=3.2e-06 [1/A^(2)]
     double sld_in_shell4;
-    //  [DEFAULT]=sld_in_shell5=3.7e-06
+    //  [DEFAULT]=sld_in_shell5=3.7e-06 [1/A^(2)]
     double sld_in_shell5;
-    //  [DEFAULT]=sld_in_shell6=4.2e-06
+    //  [DEFAULT]=sld_in_shell6=4.2e-06 [1/A^(2)]
     double sld_in_shell6;
-    //  [DEFAULT]=sld_in_shell7=4.7e-06
+    //  [DEFAULT]=sld_in_shell7=4.7e-06 [1/A^(2)]
     double sld_in_shell7;
-    //  [DEFAULT]=sld_in_shell8=5.2e-06
+    //  [DEFAULT]=sld_in_shell8=5.2e-06 [1/A^(2)]
     double sld_in_shell8;
-    //  [DEFAULT]=sld_in_shell9=5.7e-06
+    //  [DEFAULT]=sld_in_shell9=5.7e-06 [1/A^(2)]
     double sld_in_shell9;
-    //  [DEFAULT]=sld_in_shell10=6.0e-06
+    //  [DEFAULT]=sld_in_shell10=6.0e-06 [1/A^(2)]
     double sld_in_shell10;
 
@@ -117,23 +117,23 @@
     double A_shell10;
 
-    //  [DEFAULT]=thick_shell1=50.0
+    //  [DEFAULT]=thick_shell1=50.0 [A]
     double thick_shell1;
-    //  [DEFAULT]=thick_shell2=50.0
+    //  [DEFAULT]=thick_shell2=50.0 [A]
     double thick_shell2;
-    //  [DEFAULT]=thick_shell3=50.0
+    //  [DEFAULT]=thick_shell3=50.0 [A]
     double thick_shell3;
-    //  [DEFAULT]=thick_shell4=50.0
+    //  [DEFAULT]=thick_shell4=50.0 [A]
     double thick_shell4;
-    //  [DEFAULT]=thick_shell5=50.0
+    //  [DEFAULT]=thick_shell5=50.0 [A]
     double thick_shell5;
-    //  [DEFAULT]=thick_shell6=50.0
+    //  [DEFAULT]=thick_shell6=50.0 [A]
     double thick_shell6;
-    //  [DEFAULT]=thick_shell7=50.0
+    //  [DEFAULT]=thick_shell7=50.0 [A]
     double thick_shell7;
-    //  [DEFAULT]=thick_shell8=50.0
+    //  [DEFAULT]=thick_shell8=50.0 [A]
     double thick_shell8;
-    //  [DEFAULT]=thick_shell9=50.0
+    //  [DEFAULT]=thick_shell9=50.0 [A]
     double thick_shell9;
-    //  [DEFAULT]=thick_shell10=50.0
+    //  [DEFAULT]=thick_shell10=50.0 [A]
     double thick_shell10;
 