Index: src/sas/sasgui/guiframe/local_perspectives/plotting/AnnulusSlicer.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/AnnulusSlicer.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/AnnulusSlicer.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -498,5 +498,5 @@
         # Update locations
         self.outer_circle.update()
-        # if self.is_inside != None:
+        # if self.is_inside is not None:
         out = self._post_data()
         return out
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/Arc.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/Arc.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/Arc.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -71,7 +71,7 @@
         x = []
         y = []
-        if theta1 != None:
+        if theta1 is not None:
             self.theta1 = theta1
-        if theta2 != None:
+        if theta2 is not None:
             self.theta2 = theta2
         while self.theta2 < self.theta1:
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/Edge.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/Edge.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/Edge.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -63,9 +63,9 @@
         Draw the new roughness on the graph.
         """
-        if r1 != None:
+        if r1 is not None:
             self.r1 = r1
-        if r2 != None:
+        if r2 is not None:
             self.r2 = r2
-        if theta != None:
+        if theta is not None:
             self.theta = theta
         x1 = self.r1 * math.cos(self.theta)
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/Plotter1D.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/Plotter1D.py	(revision ac07a3acc20dbf79c564bf642aece71a02c2c862)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/Plotter1D.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -183,10 +183,10 @@
         # So manually recode the size (=x_size) and compare here.
         # Massy code to work around:<
-        if self.parent._mgr != None:
+        if self.parent._mgr is not None:
             max_panel = self.parent._mgr.GetPane(self)
             if max_panel.IsMaximized():
                 self.parent._mgr.RestorePane(max_panel)
                 max_panel.Maximize()
-        if self.x_size != None:
+        if self.x_size is not None:
             if self.x_size == self.GetSize():
                 self.resizing = False
@@ -241,5 +241,5 @@
                 xval = float(active_ctrl.GetValue())
                 position = self.get_data_xy_vals(xval)
-                if position != None and not self.is_corfunc:
+                if position is not None and not self.is_corfunc:
                     wx.PostEvent(self.parent, StatusEvent(status=position))
             except:
@@ -342,5 +342,5 @@
                 self.q_ctrl = None
                 return
-        if self.ly != None and event.xdata != None:
+        if self.ly is not None and event.xdata is not None:
             # Selecting a new line if cursor lines are displayed already
             dqmin = math.fabs(event.xdata - self.ly[0].get_xdata())
@@ -364,5 +364,5 @@
             return
         # release a q range vline
-        if self.ly != None and not self.leftdown:
+        if self.ly is not None and not self.leftdown:
             for ly in self.ly:
                 ly.set_alpha(0.7)
@@ -372,5 +372,5 @@
         if ax is None or not hasattr(event, 'action'):
             return
-        end_drag = event.action != 'drag' and event.xdata != None
+        end_drag = event.action != 'drag' and event.xdata is not None
         nop = len(self.plots)
         pos_x, _ = float(event.xdata), float(event.ydata)
@@ -514,5 +514,5 @@
         ax = event.inaxes
         PlotPanel.onLeftDown(self, event)
-        if ax != None:
+        if ax is not None:
             try:
                 pos_x = float(event.xdata)  # / size_x
@@ -683,5 +683,5 @@
 
 
-        if self.position != None:
+        if self.position is not None:
             wx_id = ids.next()
             self._slicerpop.Append(wx_id, '&Add Text')
@@ -760,5 +760,5 @@
             default_name = default_name.split('.')[0]
         default_name += "_out"
-        if self.parent != None:
+        if self.parent is not None:
             self.parent.save_data1d(data, default_name)
 
@@ -778,5 +778,5 @@
             default_name = default_name.split('.')[0]
         # default_name += "_out"
-        if self.parent != None:
+        if self.parent is not None:
             self.parent.show_data1d(data, default_name)
 
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/Plotter2D.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/Plotter2D.py	(revision ac07a3acc20dbf79c564bf642aece71a02c2c862)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/Plotter2D.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -156,5 +156,5 @@
         PlotPanel.onLeftDown(self, event)
         ax = event.inaxes
-        if ax != None:
+        if ax is not None:
             # data coordinate position
             pos_x = "%8.3g" % event.xdata
@@ -264,5 +264,5 @@
         # control axis labels from the panel itself
         yname, yunits = data.get_yaxis()
-        if self.yaxis_label != None:
+        if self.yaxis_label is not None:
             yname = self.yaxis_label
             yunits = self.yaxis_unit
@@ -271,5 +271,5 @@
             self.yaxis_unit = yunits
         xname, xunits = data.get_xaxis()
-        if self.xaxis_label != None:
+        if self.xaxis_label is not None:
             xname = self.xaxis_label
             xunits = self.xaxis_unit
@@ -355,5 +355,5 @@
             slicerpop.Append(wx_id, '&Box Averaging in Qy')
             wx.EVT_MENU(self, wx_id, self.onBoxavgY)
-            if self.slicer != None:
+            if self.slicer is not None:
                 wx_id = ids.next()
                 slicerpop.Append(wx_id, '&Clear Slicer')
@@ -435,5 +435,5 @@
                 msg = "Add Text: Error. Check your property values..."
                 logger.error(msg)
-                if self.parent != None:
+                if self.parent is not None:
                     wx.PostEvent(self.parent, StatusEvent(status=msg))
         dial.Destroy()
@@ -629,5 +629,5 @@
 
         """
-        if self.slicer != None:
+        if self.slicer is not None:
             from SlicerParameters import SlicerParameterPanel
             dialog = SlicerParameterPanel(self, -1, "Slicer Parameters")
@@ -735,5 +735,5 @@
         """
         event_id = str(evt.GetId())
-        if self.parent != None:
+        if self.parent is not None:
             self._default_save_location = self.parent._default_save_location
         default_name = self.plots[self.graph.selected_plottable].label
@@ -759,5 +759,5 @@
             default_name = default_name.split('.')[0]
         #default_name += "_out"
-        if self.parent != None:
+        if self.parent is not None:
             self.parent.show_data2d(data, default_name)
 
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/SectorSlicer.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/SectorSlicer.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/SectorSlicer.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -362,5 +362,5 @@
         self.left_moving = left
         theta3 = 0
-        if phi != None:
+        if phi is not None:
             self.phi = phi
         if delta is None:
@@ -374,5 +374,5 @@
             self.theta = mline.theta + self.phi
 
-        if mline != None:
+        if mline is not None:
             if delta != 0:
                 self.theta2 = mline + delta
@@ -538,5 +538,5 @@
         """
 
-        if theta != None:
+        if theta is not None:
             self.theta = theta
         x1 = self.radius * math.cos(self.theta)
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/SimplePlot.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/SimplePlot.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/SimplePlot.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -87,5 +87,5 @@
             pos = (pos_x, pos_y + 5)
         self.PopupMenu(slicerpop, pos)
-        if self.scale != None:
+        if self.scale is not None:
             self.parent.scale2d = self.scale
 
@@ -106,5 +106,5 @@
             self.leftdown = True
             ax = event.inaxes
-            if ax != None:
+            if ax is not None:
                 self.xInit, self.yInit = event.xdata, event.ydata
                 try:
@@ -123,5 +123,5 @@
         """
         self.resizing = False
-        if self.x_size != None:
+        if self.x_size is not None:
             if self.x_size == self.GetSize():
                 self.canvas.set_resizing(self.resizing)
@@ -161,7 +161,7 @@
         self.plots[plot.name] = plot
         # Axis scales
-        if plot.xtransform != None:
+        if plot.xtransform is not None:
             self.xLabel = plot.xtransform
-        if plot.ytransform != None:
+        if plot.ytransform is not None:
             self.yLabel = plot.ytransform
         # Init graph
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/boxMask.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/boxMask.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/boxMask.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -123,5 +123,5 @@
                                          x2=self.vertical_lines.x2,
                                          width=self.vertical_lines.half_width)
-        # if self.is_inside != None:
+        # if self.is_inside is not None:
         out = self._post_data()
         return out
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/boxSlicer.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/boxSlicer.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/boxSlicer.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -147,5 +147,5 @@
         y_max = math.fabs(self.horizontal_lines.y)
 
-        if nbins != None:
+        if nbins is not None:
             self.nbins = nbins
         if self.averager is None:
@@ -357,7 +357,7 @@
         """
         # # Reset x, y- coordinates if send as parameters
-        if x != None:
+        if x is not None:
             self.x = np.sign(self.x) * math.fabs(x)
-        if y != None:
+        if y is not None:
             self.y = np.sign(self.y) * math.fabs(y)
         # # Draw lines and markers
@@ -464,7 +464,7 @@
         """
         # # reset x, y -coordinates if given as parameters
-        if x != None:
+        if x is not None:
             self.x = np.sign(self.x) * math.fabs(x)
-        if y != None:
+        if y is not None:
             self.y = np.sign(self.y) * math.fabs(y)
         # # draw lines and markers
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/boxSum.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/boxSum.py	(revision d85c194ea2f78cb2b9b3de9c969e1b8ebea6b6d2)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/boxSum.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -353,7 +353,7 @@
             Draw the new roughness on the graph.
         """
-        if center_x != None:
+        if center_x is not None:
             self.x = center_x
-        if center_y != None:
+        if center_y is not None:
             self.y = center_y
         self.center_marker.set(xdata=[self.x], ydata=[self.y])
@@ -490,11 +490,11 @@
         """
         # # save the new height, witdh of the rectangle if given as a param
-        if width != None:
+        if width is not None:
             self.half_width = width
-        if height != None:
+        if height is not None:
             self.half_height = height
         # # If new  center coordinates are given draw the rectangle
         # #given these value
-        if center != None:
+        if center is not None:
             self.center_x = center.x
             self.center_y = center.y
@@ -511,11 +511,11 @@
             return
         # # if x1, y1, y2, y3 are given draw the rectangle with this value
-        if x1 != None:
+        if x1 is not None:
             self.x1 = x1
-        if x2 != None:
+        if x2 is not None:
             self.x2 = x2
-        if y1 != None:
+        if y1 is not None:
             self.y1 = y1
-        if y2 != None:
+        if y2 is not None:
             self.y2 = y2
         # # Draw 2 vertical lines and a marker
@@ -657,11 +657,11 @@
         """
         # # save the new height, witdh of the rectangle if given as a param
-        if width != None:
+        if width is not None:
             self.half_width = width
-        if height != None:
+        if height is not None:
             self.half_height = height
         # # If new  center coordinates are given draw the rectangle
         # #given these value
-        if center != None:
+        if center is not None:
             self.center_x = center.x
             self.center_y = center.y
@@ -679,11 +679,11 @@
             return
         # # if x1, y1, y2, y3 are given draw the rectangle with this value
-        if x1 != None:
+        if x1 is not None:
             self.x1 = x1
-        if x2 != None:
+        if x2 is not None:
             self.x2 = x2
-        if y1 != None:
+        if y1 is not None:
             self.y1 = y1
-        if y2 != None:
+        if y2 is not None:
             self.y2 = y2
         # # Draw 2 vertical lines and a marker
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/detector_dialog.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/detector_dialog.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/detector_dialog.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -155,7 +155,7 @@
         self.qmax_ctl.SetLabel(str(format_number(qmax)))
         self.beam_ctl.SetLabel(str(format_number(beam)))
-        if zmin != None:
+        if zmin is not None:
             self.zmin_ctl.SetValue(str(format_number(zmin)))
-        if zmax != None:
+        if zmax is not None:
             self.zmax_ctl.SetValue(str(format_number(zmax)))
 
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/masking.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/masking.py	(revision ac07a3acc20dbf79c564bf642aece71a02c2c862)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/masking.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -100,5 +100,5 @@
         wx.Dialog.__init__(self, parent, id=id, *args, **kwds)
 
-        if data != None:
+        if data is not None:
             # Font size
             kwds = []
@@ -235,5 +235,5 @@
         event.Skip()
         # from boxMask import BoxMask
-        if event != None:
+        if event is not None:
             self._on_clear_slicer(event)
         self.slicer_z += 1
@@ -336,5 +336,5 @@
         """
         # the case of liitle numbers of True points
-        if len(mask[mask]) < 10 and self.data != None:
+        if len(mask[mask]) < 10 and self.data is not None:
             self.ShowMessage()
             mask = copy.deepcopy(self.mask)
@@ -355,5 +355,5 @@
         temp_data.data[mask == False] = temp_mask[mask == False]
         self.plotpanel.clear()
-        if self.slicer != None:
+        if self.slicer is not None:
             self.slicer.clear()
             self.slicer = None
@@ -460,5 +460,5 @@
         wx.Dialog.__init__(self, parent, id=id, *args, **kwds)
 
-        if data != None:
+        if data is not None:
             # Font size
             kwds = []
@@ -710,5 +710,5 @@
         Status msg
         """
-        if self.parent.parent.parent != None:
+        if self.parent.parent.parent is not None:
             wx.PostEvent(self.parent.parent.parent,
                          StatusEvent(status=msg, type=type))
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/profile_dialog.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/profile_dialog.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/profile_dialog.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -44,5 +44,5 @@
         wx.Dialog.__init__(self, parent, id=id, *args, **kwds)
 
-        if data != None:
+        if data is not None:
             #Font size
             kwds = []
@@ -284,5 +284,5 @@
             default_name = default_name.split('.')[0]
         default_name += "_out"
-        if self.parent != None:
+        if self.parent is not None:
             # What an ancestor!
             fit_panel = self.parent.parent.parent
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/sector_mask.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/sector_mask.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/sector_mask.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -96,5 +96,5 @@
             self.left_line.update(phi=self.right_line.phi, delta=None,
                                   mline=self.main_line, side=True, left=False)
-        #if self.is_inside != None:
+        #if self.is_inside is not None:
         out = self._post_data()
         return out
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/slicerpanel.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/slicerpanel.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/slicerpanel.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
@@ -114,5 +114,5 @@
         self.Layout()
         psizer = self.parent.GetSizer()
-        if psizer != None:
+        if psizer is not None:
             psizer.Layout()
 