Index: src/sas/guiframe/gui_manager.py
===================================================================
--- src/sas/guiframe/gui_manager.py	(revision 3db44fbfe87ababed011758181e38e2806c5aac2)
+++ src/sas/guiframe/gui_manager.py	(revision 7801df83258dc0f0d45838a3596f5e58f88bbcd3)
@@ -44,5 +44,4 @@
 from sas.dataloader.loader import Loader
 from matplotlib import _pylab_helpers
-from documentation_window import DocumentationWindow
 
 def get_app_dir():
@@ -2166,4 +2165,5 @@
         # Running SasView "in-place" using run.py means the docs will be in a
         # different place than they would otherwise.
+        from documentation_window import DocumentationWindow
         DocumentationWindow(self, -1, "index.html", "", "SasView Documentation")
 
Index: src/sas/perspectives/calculator/model_editor.py
===================================================================
--- src/sas/perspectives/calculator/model_editor.py	(revision 4b5fe6557247db3990ee1d03c9755649faa93171)
+++ src/sas/perspectives/calculator/model_editor.py	(revision 7801df83258dc0f0d45838a3596f5e58f88bbcd3)
@@ -278,5 +278,5 @@
         self.help_button = wx.Button(self, -1, 'HELP')
         _app_tip = "Help on composite model creation."
-        self.help_butto.SetToolTipString(_app_tip)
+        self.help_button.SetToolTipString(_app_tip)
         self.help_button.Bind(wx.EVT_BUTTON, self.on_help)
         self.close_button = wx.Button(self, wx.ID_CANCEL, 'Close')
Index: src/sas/perspectives/fitting/basepage.py
===================================================================
--- src/sas/perspectives/fitting/basepage.py	(revision 3db44fbfe87ababed011758181e38e2806c5aac2)
+++ src/sas/perspectives/fitting/basepage.py	(revision 7801df83258dc0f0d45838a3596f5e58f88bbcd3)
@@ -2951,6 +2951,6 @@
         """
 
-        _TreeLocation = "user/perspectives/fitting/fitting_help.html"
-        _PageAnchor = "#polydispersity-distributions"
+        _TreeLocation = "user/perspectives/fitting/pd_help.html"
+        _PageAnchor = ""
         _doc_viewer = DocumentationWindow(self, -1, _TreeLocation,
                                           _PageAnchor, "Polydispersity Help")
Index: src/sas/perspectives/fitting/fitpage.py
===================================================================
--- src/sas/perspectives/fitting/fitpage.py	(revision 526542037f3eafd1f7f48d2365935e46d6fe7c26)
+++ src/sas/perspectives/fitting/fitpage.py	(revision 7801df83258dc0f0d45838a3596f5e58f88bbcd3)
@@ -16,4 +16,5 @@
 from sas.guiframe.utils import format_number
 from sas.guiframe.utils import check_float
+from sas.guiframe.documentation_window import DocumentationWindow
 
 (Chi2UpdateEvent, EVT_CHI2_UPDATE) = wx.lib.newevent.NewEvent()
@@ -188,6 +189,8 @@
     def _fill_range_sizer(self):
         """
-        Fill the sizer containing the plotting range
-        add  access to npts
+        Fill the Fitting sizer on the fit panel which contains: the smearing
+        information (dq), the weighting information (dI or other), the plotting
+        range, access to the 2D mask editor, the compute, fit, and help
+        buttons, xi^2, number of points etc.
         """
         is_2Ddata = False
@@ -265,5 +268,5 @@
         weighting_box.Add(sizer_weighting)
 
-        sizer_fit = wx.GridSizer(2, 4, 2, 6)
+        sizer_fit = wx.GridSizer(2, 5, 2, 6)
 
         # combobox for smear2d accuracy selection
@@ -284,4 +287,14 @@
         self.btFit.SetToolTipString("Start fitting.")
 
+        #General Help button
+        self.btFitHelp = wx.Button(self, -1, 'HELP')
+        self.btFitHelp.SetToolTipString("General Fitting Help.")
+        self.btFitHelp.Bind(wx.EVT_BUTTON, self._onFitHelp)
+        
+        #Resolution Smearing Help button
+        self.btSmearHelp = wx.Button(self, -1, '?')
+        self.btSmearHelp.SetToolTipString("Resolution Smearing Help.")
+        self.btSmearHelp.Bind(wx.EVT_BUTTON, self._onSmearHelp)
+        
         #textcntrl for custom resolution
         self.smear_pinhole_max = ModelTextCtrl(self, -1,
@@ -391,8 +404,10 @@
         #sizer_fit.Add(box_description_3, 0, 0)
         sizer_fit.Add(self.draw_button, 0, 0)
+        sizer_fit.Add((-1,5))
         sizer_fit.Add(self.tcChi, 0, 0)
         sizer_fit.Add(self.Npts_fit, 0, 0)
         sizer_fit.Add(self.Npts_total, 0, 0)
         sizer_fit.Add(self.btFit, 0, 0)
+        sizer_fit.Add(self.btFitHelp, 0, 0)
 
         # StaticText for smear
@@ -1046,4 +1061,43 @@
         self.fit_started = self._manager.onFit(uid=self.uid)
         wx.CallAfter(self.set_fitbutton)
+
+    def _onFitHelp(self, event):
+        """
+        Bring up the Full Fitting Documentation whenever the HELP button is
+        clicked.
+
+        Calls DocumentationWindow with the path of the location within the
+        documentation tree (after /doc/ ....".  Note that when using old
+        versions of Wx (before 2.9) and thus not the release version of
+        installers, the help comes up at the top level of the file as
+        webbrowser does not pass anything past the # to the browser when it is
+        running "file:///...."
+
+    :param evt: Triggers on clicking the help button
+    """
+
+        _TreeLocation = "user/perspectives/fitting/fitting_help.html"
+        _doc_viewer = DocumentationWindow(self, -1, _TreeLocation, "",
+                                          "General Fitting Help")
+
+    def _onSmearHelp(self, event):
+        """
+        Bring up the instrumental resolution smearing Documentation whenever
+        the ? button in the smearing box is clicked.
+
+        Calls DocumentationWindow with the path of the location within the
+        documentation tree (after /doc/ ....".  Note that when using old
+        versions of Wx (before 2.9) and thus not the release version of
+        installers, the help comes up at the top level of the file as
+        webbrowser does not pass anything past the # to the browser when it is
+        running "file:///...."
+
+    :param evt: Triggers on clicking the help button
+    """
+
+        _TreeLocation = "user/perspectives/fitting/sm_help.html"
+        _doc_viewer = DocumentationWindow(self, -1, _TreeLocation, "",
+                                          "Instrumental Resolution Smearing \
+                                          Help")
 
     def set_fitbutton(self):