Index: sansview/releases_notes.txt
===================================================================
--- sansview/releases_notes.txt	(revision 7774b8110830ee4511d1c3e1b13388095e8ea125)
+++ sansview/releases_notes.txt	(revision 7872aefddb72b917c0e592e1f17c11609232c026)
@@ -2,11 +2,24 @@
 =============
 
-SansView 0.9.1
+SansView 1.0
 
 Package name: None
 
-1- Version 0.9.1
+1- Version 1.0
 
-	- Release date: 05/01/2009
+	- Release date: 10/01/2009
+  	- Implemented P(r) inversion (Indirect Fourier transformations).
+	- Improved fitting and model caculation speed by a factor of ten.
+  	- Supporting many more model functions.
+	- Supporting P(Q)*S(Q) for most of the shape based form factors.
+	- Added more distribution functions for the polydispersion calculations.
+	- Added a bookmarking feature so that the results of the calculation can be recalled later.
+	- Q range reset button is added.
+	- Added a color bar in 2D data plots.
+	- Added a model function detail button for an easy access to the model help from the fitting panel.
+	- And much more. 
+	
+ - Previous Versions
+ 
 	- Simultaneous fit of a number of different sets of data with/without the constraints. 
 	- Loading and displaying 1D and 2D data of various formats.
@@ -22,5 +35,4 @@
 	- Save the fit panel or model panel status.
 	- Support saving data in the formats of ASCII and xml.
-	And many more. 
 
 
@@ -31,15 +43,17 @@
 
 	2.2- Installing:
-		- Get the code from svn://danse.us/sans/releases/sansview-0.9.1 
-			(after all dependent packages/modules are installed/compiled, run 'python sansview.py' under the 'sansview-0.9.1' folder)
+		- Get the code from svn://danse.us/sans/releases/sansview-1.0 
+			(after all dependent packages/modules are installed/compiled, run 'python sansview.py' under the 'sansview-1.0' folder)
 		- This application is also dependent on the following DANSE code:
-			svn://danse.us/sans/releases/guiframe-0.1.6 (run 'python setup.py install' under the 'guiframe-0.1.6' folder)
-			svn://danse.us/sans/releases/guicomm-0.1.2 (run 'python setup.py install' under the 'guicomm-0.1.2' folder)
-			svn://danse.us/sans/releases/DataLoader-0.2.3 (run 'python setup.py install' under the 'DataLoader-0.2.3' folder)
-			svn://danse.us/sans/releases/park_integration-0.1.2 (run 'python setup.py install' under the 'park_integration-0.1.2' folder)
-			svn://danse.us/sans/releases/sansmodels-0.4.4 (run 'python setup.py install' under the 'sansmodels-0.4.4\src\' folder)
+			svn://danse.us/sans/releases/guiframe-0.1.8 (run 'python setup.py install' under the 'guiframe-0.1.8' folder)
+			svn://danse.us/sans/releases/guicomm-0.1.3 (run 'python setup.py install' under the 'guicomm-0.1.3' folder)
+			svn://danse.us/sans/releases/DataLoader-0.2.5 (run 'python setup.py install' under the 'DataLoader-0.2.5' folder)
+			svn://danse.us/sans/releases/park_integration-0.1.3 (run 'python setup.py install' under the 'park_integration-0.1.3' folder)
+			svn://danse.us/sans/releases/sansmodels-0.4.5 (run 'python setup.py install' under the 'sansmodels-0.4.5\src\' folder)
 			svn://danse.us/park/releases/park-1.2 (run 'python setup.py install' under the 'park-1.2' folder)
-	        svn://danse.us/common/releases/plottools-0.1.5 (run 'python setup.py install'under the 'plottools-0.1.5\trunk\' folder)
-	        svn://danse.us/common/releases/util-0.1.1 (run 'python setup.py install'under the 'util-0.1.1' folder)
+	        svn://danse.us/common/releases/plottools-0.1.7 (run 'python setup.py install'under the 'plottools-0.1.7\trunk\' folder)
+	        svn://danse.us/common/releases/util-0.1.3 (run 'python setup.py install'under the 'util-0.1.2' folder)
+	        svn://danse.us/sans/releases/pr_inversion-0.2.3 (run 'python setup.py install'under the 'pr_inversion-0.2.3' folder)
+	        svn://danse.us/sans/releases/prview-0.3.1 (run 'python setup.py install'under the 'prview-0.3.1' folder)
 		- The following modules are required:
 			* matplotlib >= 0.98.3
@@ -47,7 +61,8 @@
 			* scipy
 			* wxpython 2.8 unicode
-			* pyxml >= 0.8.4 (for python 2.5)
+			* lxml
 			* PIL (Python Image Library)
 			* MinGW (for windows) or other GNU compiler (gcc)
+
 
 3- Known Issues
@@ -57,5 +72,6 @@
 
 	3.2- Windows:
-		- Fixed a bug in the version 0.9.0 that consists of always taking the fitting weights evenly for all data points even though the data set has dI in it.
+		- None
+		
 	3.3- Linux:
 		- None